<?xml version="1.0" encoding="UTF-8"?>
<!-- This file is part of deegree, for copyright/license information, please visit http://www.deegree.org/license. -->
<xsl:stylesheet version="1.0"
 xmlns="http://www.opengis.net/context"
 xmlns:csw="http://www.opengis.net/cat/csw/2.0.2"
 xmlns:ogc="http://www.opengis.net/ogc"
 xmlns:xlink="http://www.w3.org/1999/xlink"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
 xmlns:gco="http://www.isotc211.org/2005/gco" 
 xmlns:gmd="http://www.isotc211.org/2005/gmd" 
 xmlns:srv="http://www.isotc211.org/2005/srv">
     
    <xsl:output method="html" media-type="text/html" omit-xml-declaration="yes" encoding="UTF-8"/>

    <xsl:param name="CATALOG"/>
    <xsl:param name="SERVICECATALOGS"/>
    <xsl:param name="METAVERSION"/>

    <!-- Please adapt the paths "/home/deegree/igeoportal-std/" to your machine -->
    <xsl:include href="./metaOverview2html.xsl"/>
    <xsl:include href="./metaDetails2html.xsl"/>

    <xsl:template match="ogc:ServiceExceptionReport">
        <table class="except">
            <tr>
                <td class="key">Error</td>
                <td class="val"><xsl:value-of select="./ogc:ServiceException"/></td>
            </tr>
        </table>
    </xsl:template>

    <xsl:template match="csw:GetRecordByIdResponse">
        <table align="center">
            <tr>
                <td>
                    <xsl:if test="$METAVERSION = 'overview'">
                        <p class="title">searchResult item overview</p>
                    </xsl:if>
                    <xsl:if test="$METAVERSION = 'detailed'">
                        <p class="title">searchResult item details</p>
                    </xsl:if>
                </td>
            </tr>
            <tr>
                <td>
                    <xsl:if test="$METAVERSION = 'overview'">
                        <xsl:call-template name="OV_MD_Metadata"/>
                    </xsl:if>
                    <xsl:if test="$METAVERSION = 'detailed'">
                        <xsl:call-template name="DE_MD_Metadata"/>
                    </xsl:if>
                </td>
            </tr>
        </table>
    </xsl:template>

</xsl:stylesheet>
