<!-- This file is part of deegree, for copyright/license information, please visit http://www.deegree.org/license. -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:cntxt="http://www.opengis.net/context" xmlns:sld="http://www.opengis.net/sld" xmlns:deegree="http://www.deegree.org/context" xmlns:xlink="http://www.w3.org/1999/xlink">
	<xsl:template match="deegree:Frontend">
		<body onload="onLoadingPage()">
			<table border="0" cellpadding="0" cellspacing="0" style="position:absolute; left:0px; top:0px">
				<tbody>
					<tr>
						<td width="1">
							<img src="./images/space.gif" width="0" height="2"/>
						</td>
						<td width="*">
							<table border="0" cellpadding="0" cellspacing="0">
                                <xsl:attribute name="width"><xsl:value-of select="$vClientWidth"/></xsl:attribute>
                                <xsl:attribute name="height"><xsl:value-of select="$vClientHeight"/></xsl:attribute>
								<!-- header -->
								<xsl:if test="./deegree:Header">
									<tr>
										<td colspan="3" id="Header">
											<iframe id="HEADER" width="100%" marginwidth="0" marginheight="0" frameborder="0" scrolling="no">
												<xsl:attribute name="src"><xsl:value-of select="./deegree:Header"/>?TITLE=<xsl:value-of select="../../cntxt:Title"/></xsl:attribute>
												<xsl:attribute name="height"><xsl:value-of select="$vHeaderHeight"/></xsl:attribute>
											</iframe>
										</td>
									</tr>
								</xsl:if>
								<!-- North -->
								<xsl:if test="./deegree:North">
									<tr>
										<xsl:attribute name="height"><xsl:value-of select="$vNorthHeight"/></xsl:attribute>
										<td colspan="3" id="North" class="feNorth">
											<xsl:if test="./deegree:North/@hidden != 'true'">
												<xsl:apply-templates  select="./deegree:North">
													<xsl:with-param name="AREA">north</xsl:with-param>
												</xsl:apply-templates>													
											</xsl:if>
										</td>
									</tr>
								</xsl:if>
								<tr>
									<!-- West -->
									<td colspan="1" id="West" valign="top" class="feWest">
										<xsl:if test="./deegree:West">
											<xsl:if test="./deegree:West/@hidden != 'true'">
												<xsl:apply-templates  select="./deegree:West">
													<xsl:with-param name="AREA">west</xsl:with-param>
												</xsl:apply-templates>
											</xsl:if>
										</xsl:if>
									</td>
									<!-- Center -->
									<td colspan="1" id="Center" valign="top" align="center" class="feCenter">
										<xsl:if test="./deegree:Center">
											<xsl:if test="./deegree:Center/@hidden != 'true'">
												<xsl:apply-templates  select="./deegree:Center">
													<xsl:with-param name="AREA">center</xsl:with-param>
												</xsl:apply-templates>
											</xsl:if>
										</xsl:if>
									</td>
									<!-- East -->
									<td colspan="1" id="East" valign="top" class="feEast">
										<xsl:if test="./deegree:East">
											<xsl:if test="./deegree:East/@hidden != 'true'">
												<xsl:apply-templates  select="./deegree:East">
													<xsl:with-param name="AREA">east</xsl:with-param>
												</xsl:apply-templates>
											</xsl:if>
										</xsl:if>
									</td>
								</tr>
								<!-- South -->
								<xsl:if test="./deegree:South">
									<tr>
										<xsl:attribute name="height"><xsl:value-of select="$vSouthHeight"/></xsl:attribute>
										<td colspan="3" id="South" class="feSouth">
											<xsl:if test="./deegree:South/@hidden != 'true'">
												<xsl:apply-templates  select="./deegree:South">
													<xsl:with-param name="AREA">south</xsl:with-param>
												</xsl:apply-templates>
											</xsl:if>
										</td>
									</tr>
								</xsl:if>
								<!-- footer -->
								<xsl:if test="./deegree:Footer">
									<tr>
										<td colspan="3" id="Footer">
											<xsl:if test="./deegree:Footer">
												<iframe id="FOOTER" width="100%" marginwidth="0" marginheight="0" frameborder="0" scrolling="no">
													<xsl:attribute name="src"><xsl:value-of select="./deegree:Footer"/></xsl:attribute>
													<xsl:attribute name="height"><xsl:value-of select="$vFooterHeight"/></xsl:attribute>
												</iframe>
											</xsl:if>
										</td>
									</tr>
								</xsl:if>
							</table>
						</td>
					</tr>
				</tbody>
			</table>
			<form action=""/>
			<!-- new form is used to switch from NormalScreen to FullScreen and vice versa -->
			<form action="control" id="scaleScreen" name="test" method="post">
				<input type="hidden" id="hiddenScaleScreen" name="rpc" value=""/>
			</form>
			<xsl:for-each select="*/deegree:Module">
				<xsl:if test="./@hidden != 'true'">
					<xsl:if test="./@type = 'menu'">
						<!-- handle pushbutton/menu modules -->
						<xsl:if test="./@type = 'menu'">
							<xsl:variable name="vFunctionName">
								<xsl:value-of select="./deegree:Name"/>Listener()
                            </xsl:variable>
							<!-- create a listener object for the button/menu entry -->
							<script LANGUAGE="JavaScript1.2" TYPE="text/javascript">
                                function <xsl:value-of select="$vFunctionName"/> {
                                    this.actionPerformed = actionPerformed;
                                    function actionPerformed(event) {
                                        var win = window.open( '<xsl:value-of select="./deegree:Content"/>' ,'<xsl:value-of select="./deegree:Name"/>',
                                                               "width=650,height=420,left=100,top=0,scrollbars=yes,resizable=yes");
                                        win.focus();
                                    }
                                }
                                var bt = new PushButton( '<xsl:value-of select="./deegree:Name"/>', '<xsl:value-of select="./deegree:Name"/>',
                                                         './images/<xsl:value-of select="./deegree:Name"/>.gif', './images/<xsl:value-of select="./deegree:Name"/>_a.gif');
                                bt.setListener( new <xsl:value-of select="$vFunctionName"/>);
                                bt.paint( document, document.getElementById('BT<xsl:value-of select="./deegree:Name"/>'  ) );
                            </script>
						</xsl:if>
					</xsl:if>
				</xsl:if>
			</xsl:for-each>
		</body>
	</xsl:template>
	
	<xsl:template match="deegree:North | deegree:East | deegree:West | deegree:South | deegree:Center">		
		<xsl:param name="AREA"></xsl:param>
		<xsl:choose>
			<xsl:when test="./@overlay = 'true' or ./@overlay = '1' ">
				<!-- area is overlayed -->
				<xsl:variable name="LEFT">
					<xsl:if test="./@left != 0">
						<xsl:value-of select="concat( 'left:', ./@left, 'px; ' )"/>
					</xsl:if>
				</xsl:variable>
				<xsl:variable name="TOP">
					<xsl:if test="./@top != 0">
						<xsl:value-of select="concat( 'top:', ./@top, 'px; ' )"/>
					</xsl:if>
				</xsl:variable>
				<xsl:variable name="RIGHT">
					<xsl:if test="./@right != 0">
						<xsl:value-of select="concat( 'right:', ./@right, 'px; ' )"/>
					</xsl:if>
				</xsl:variable>
				<xsl:variable name="BOTTOM">
					<xsl:if test="./@bottom != 0">
						<xsl:value-of select="concat( 'bottom:', ./@bottom, 'px; ' )"/>
					</xsl:if>					
				</xsl:variable>
				<xsl:variable name="WIDTH">
					<xsl:if test="./@width != 0">
						<xsl:value-of select="concat( 'width:', ./@width, 'px; ' )"/>
					</xsl:if>
				</xsl:variable>
				<div>
					<xsl:attribute name="id"><xsl:value-of select="concat( $AREA, 'Window_closed' )"/></xsl:attribute>
					<xsl:attribute name="class"><xsl:value-of select="concat( $AREA, 'Window' )"/></xsl:attribute>
					<xsl:attribute name="style"><xsl:value-of select="concat( $LEFT, $TOP, $RIGHT, $BOTTOM, $WIDTH)"/></xsl:attribute>
					<xsl:if test="./@header = 'true' or ./@header = '1' ">
						<div class="windowHeaderClosed" >
                            <xsl:attribute name="style"><xsl:value-of select="$WIDTH"/></xsl:attribute>
							<a style="position:absolute; top:2px; right:5px">
								<xsl:attribute name="href"><xsl:value-of select="concat( 'javascript:closeAreaWindow( %22', $AREA, 'Window_closed%22 );' )"/></xsl:attribute>
								<img src="./images/reopen.gif" border="0"/>
							</a>
						</div>
					</xsl:if>
				</div>
				<div>
					<xsl:attribute name="id"><xsl:value-of select="concat( $AREA, 'Window' )"/></xsl:attribute>
					<xsl:attribute name="class"><xsl:value-of select="concat( $AREA, 'Window' )"/></xsl:attribute>
					<xsl:attribute name="style"><xsl:value-of select="concat( $LEFT, $TOP, $RIGHT, $BOTTOM, $WIDTH)"/></xsl:attribute>
					<xsl:if test="./@header = 'true' or ./@header = '1' ">
						<div class="windowHeader" >
                            <xsl:attribute name="style"><xsl:value-of select="$WIDTH"/></xsl:attribute>
							<a style="position:absolute; top:2px; right:5px">
								<xsl:attribute name="href"><xsl:value-of select="concat( 'javascript:closeAreaWindow( %22', $AREA, 'Window%22 );' )"/></xsl:attribute>
								<img src="./images/minimize.gif" border="0"/>
							</a>
						</div>
					</xsl:if>
					<xsl:for-each select="./deegree:Module">
                    <!-- 
						<div style="position:static; width:250px; height:5px; background: #999999;">
						
						</div>
                        -->
						<xsl:if test="./@type = 'content'">
							<iframe marginheight="0" marginwidth="0" frameborder="0" >
								<xsl:attribute name="id"><xsl:value-of select="./deegree:Name"/></xsl:attribute>
								<xsl:attribute name="src"><xsl:value-of select="./deegree:Content"/></xsl:attribute>
								<xsl:attribute name="scrolling">auto</xsl:attribute>
								<xsl:attribute name="width"><xsl:value-of select="$vEastWidth"/></xsl:attribute>
								<!-- use usedefined height if available -->
								<xsl:if test="./@height">
									<xsl:attribute name="height"><xsl:value-of select="./@height"/></xsl:attribute>
								</xsl:if>
							</iframe>
						</xsl:if>
					</xsl:for-each>
				</div>
			</xsl:when>
			<xsl:otherwise>
				<!-- area is not overlayed -->
				<table border="0" cellpadding="0" cellspacing="0">
					<tbody>
						<tr>
							<td colspan="3">
								<img src="./imgages/space.gif" alt="" width="0" height="10" border="0"/>
							</td>
						</tr>
						<tr>
							<td>
								<img src="./imgages/space.gif" alt="" width="10" height="1" border="0"/>
							</td>
							<td>
								<xsl:for-each select="./deegree:Module">
									<xsl:choose>
										<xsl:when test="./@overlay = 'true' or ./@overlay = '1' ">
											<!-- module is overlayed -->
											<xsl:variable name="LEFT">
												<xsl:if test="./@left != 0">
													<xsl:value-of select="concat( 'left:', ./@left, 'px; ' )"/>
												</xsl:if>
											</xsl:variable>
											<xsl:variable name="TOP">
												<xsl:if test="./@top != 0">
													<xsl:value-of select="concat( 'top:', ./@top, 'px; ' )"/>
												</xsl:if>
											</xsl:variable>
											<xsl:variable name="RIGHT">
												<xsl:if test="./@right != 0">
													<xsl:value-of select="concat( 'right:', ./@right, 'px; ' )"/>
												</xsl:if>
											</xsl:variable>
											<xsl:variable name="BOTTOM">
												<xsl:if test="./@bottom != 0">
													<xsl:value-of select="concat( 'bottom:', ./@bottom, 'px; ' )"/>
												</xsl:if>
											</xsl:variable>
											<xsl:variable name="WIDTH">
												<xsl:if test="./@width != 0">
													<xsl:value-of select="concat( 'width:', ./@width, 'px; ' )"/>
												</xsl:if>
											</xsl:variable>                                           
                                             <div>
                            					<xsl:attribute name="id"><xsl:value-of select="concat( ./deegree:Name, 'Window_closed' )"/></xsl:attribute>
                            					<xsl:attribute name="class"><xsl:value-of select="concat( 'class', ./deegree:Name)"/></xsl:attribute>
                            					<xsl:attribute name="style"><xsl:value-of select="concat( $LEFT, $TOP, $RIGHT, $BOTTOM, $WIDTH )"/></xsl:attribute>
                            					<xsl:if test="./@header = 'true' or ./@header = '1' ">
                            						<div class="windowHeaderClosed" >
                                                        <xsl:attribute name="style"><xsl:value-of select="$WIDTH"/></xsl:attribute>
                            							<a style="position:absolute; top:2px; right:5px">
                            								<xsl:attribute name="href"><xsl:value-of select="concat( 'javascript:closeAreaWindow( %22', ./deegree:Name, 'Window_closed%22 );' )"/></xsl:attribute>
                            								<img src="./images/reopen.gif" border="0"/>
                            							</a>
                            						</div>
                            					</xsl:if>
                            				</div>
                                            <div>
                                                <xsl:attribute name="id"><xsl:value-of select="concat( ./deegree:Name, 'Window' )"/></xsl:attribute>
                                                <xsl:attribute name="class"><xsl:value-of select="concat( 'class', ./deegree:Name)"/></xsl:attribute>
                                                <xsl:attribute name="style"><xsl:value-of select="concat( $LEFT, $TOP, $RIGHT, $BOTTOM, $WIDTH)"/></xsl:attribute>
                                                <xsl:if test="./@header = 'true' or ./@header = '1' ">
                                                    <div class="windowHeader" >
                                                        <xsl:attribute name="style"><xsl:value-of select="$WIDTH"/></xsl:attribute>
                                                        <a style="position:absolute; top:2px; right:5px">
                                                            <xsl:attribute name="href"><xsl:value-of select="concat( 'javascript:closeAreaWindow( %22', ./deegree:Name, 'Window%22 );' )"/></xsl:attribute>
                                                            <img src="./images/minimize.gif" border="0"/>
                                                        </a>
                                                    </div>
                                                </xsl:if>
                                                <iframe marginheight="0" marginwidth="0" frameborder="0">
                                                    <xsl:attribute name="id"><xsl:value-of select="./deegree:Name"/></xsl:attribute>
                                                    <xsl:attribute name="src"><xsl:value-of select="./deegree:Content"/></xsl:attribute>
                                                    <xsl:attribute name="scrolling">no</xsl:attribute>
                                                    <xsl:if test="./@width">
                                                        <xsl:attribute name="width"><xsl:value-of select="./@width"/></xsl:attribute>
                                                    </xsl:if>
                                                    <xsl:if test="./@height">
                                                        <xsl:attribute name="height"><xsl:value-of select="./@height"/></xsl:attribute>
                                                    </xsl:if>
                                                </iframe>
                                            </div>             
										</xsl:when>
										<xsl:otherwise>
											<xsl:apply-templates select="."/>
										</xsl:otherwise>
									</xsl:choose>
								</xsl:for-each>
							</td>
							<td>
								<img src="./imgages/space.gif" alt="" width="10" height="1" border="0"/>
							</td>
						</tr>
					</tbody>
				</table>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>
