<!-- This file is part of deegree, for copyright/license information, please visit http://www.deegree.org/license. -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:cntxt="http://www.opengis.net/context" xmlns:sld="http://www.opengis.net/sld" xmlns:deegree="http://www.deegree.org/context" xmlns:xlink="http://www.w3.org/1999/xlink">

    <xsl:template name="INITEXTJS">

	    Ext.onReady( function() {
	           Ext.QuickTips.init(); 
	            if ( controller == null ) {
	              controller = new Controller();
	              controller.init();
	            }                   
	        });
	        
	    function initOverlayWindows() {
	        // overlayed windows
	        <xsl:for-each select="//deegree:Module">
	            <xsl:if test="./@hidden != 'true' and ./@overlay = 'true' ">
	                var win = new Ext.Window({
	                    title: '<xsl:value-of select="deegree:Name"/>',
	                    layout:'fit',
	                    width:<xsl:value-of select="./@width"/>,
	                    height: <xsl:value-of select="./@height"/>,
	                    closeAction:'hide',
	                    closable: false,
	                    collapsible: true,
	                    animCollapse: false,
	                    plain: true,
	                    x: <xsl:value-of select="./@left"/>,
	                    y: <xsl:value-of select="./@top"/>,
	                    items: [ {              
	                            html: '<xsl:call-template name="WINDOW"/>',
	                            border: false
	                            }]
	                });
	                win.show(this);
	            </xsl:if>
	        </xsl:for-each>
	    }
	
	
	    /**
	    * init extJS
	    */
	    function  init_iGeo () {
	        try {
	            initOverlayWindows();
	        } catch(e) {
	            alert( "initOverlayWindows: " + e);
	        }
	            
	        try {
	            initMenubar();
	        } catch(e) {
	            alert( "initMenubar: " + e);
	        }
	        	      
	        var vp ;
	        try {
	            vp = new Ext.Viewport (
	                {
	                    listeners: {
	                    resize: {
	                        fn: function(el, width, height) {
	                            if ( vp != null ) {
	                                 var mp = Ext.getCmp( 'MapPanel' );
	                                 if ( mp != null ) {
	                                     mp.setHeight( height - 60 - 10 ); // mpHeight = height - region:north(height) - region:north(margin top+bottom)
	                                     mp.setWidth( width );
	                                 }	                                
		                          }
		                       }
		                    }
		                },
	                    layout: 'border',                           
	                    items:[
	                        {
	                            region: 'north',
                                margins: '5 5 5 5', // top, right, bottom, left
	                            collapsible: false,
	                            split: false,
	                            height: 60,
	                            html: '<img border="0" src="./images/logo-deegree.png"></img> iGeoPortal'
                                //html: '<iframe frameborder="0" height="60" marginheight="0" marginwidth="0" scrolling="no" width="100%" src="header.html"></iframe>'
	                        },
	                        {
	                            id: 'centerfield',
	                            region: 'center',
                                border: false,
	                            items:[ 
		                            {
	                                 id: 'MapPanel',                                      
	                                 <xsl:call-template name="MAPBORDER"/>
	                                }
	                            ]	                            
	                        }
	                    ]
	                }
	            ); // end of viewport
	        } catch(e) {
	            alert( "create viewport: " + e);
	        }
	        
	        try {   
	            vp.render();
	        } catch(e) {
	            alert( "render viewport: " + e);
	        }
	        var k = 1;
	        if ( Math.random() &gt;= 0.5 ) {
	            k = -1;
	        }
	        
	        if ( navigator.appName.indexOf( "Microsoft" )!=-1 ) {              
               try  {
                    window.resizeTo(  document.body.offsetWidth - 1 , document.body.offsetHeight );
               } catch( e ) {
                    alert( "IE resize: " +  e);
               }
            } else {
               //window.resizeTo( window.innerWidth + 13 , screen.availHeight ); 
               var t = new Ext.util.DelayedTask( window.resizeTo,  window, [window.outerWidth-k , window.outerHeight] );
               t.delay( 500 );
            }
            window.resizeBy( k, k );
            window.resizeBy( -k, -k );
	        
	    } ;// end init function     
    
    </xsl:template>
</xsl:stylesheet>            