<!-- This file is part of deegree, for copyright/license information, please visit http://www.deegree.org/license. -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:cntxt="http://www.opengis.net/context" xmlns:sld="http://www.opengis.net/sld" xmlns:deegree="http://www.deegree.org/context" xmlns:xlink="http://www.w3.org/1999/xlink">

    <xsl:template name="INITEXTJS">

	    Ext.onReady( function() {
	            Ext.QuickTips.init(); 
	            if ( controller == null ) {
	              controller = new Controller();
	              controller.init();
	            }                   
	        });
	        
	    function initOverlayWindows() {
	        // overlayed windows
	        <xsl:for-each select="//deegree:Module">
	            <xsl:if test="./@hidden != 'true' and ./@overlay = 'true' ">
	                var win = new Ext.Window({
	                    title: '<xsl:value-of select="deegree:Name"/>',
	                    layout:'fit',
	                    width:<xsl:value-of select="./@width"/>,
	                    height: <xsl:value-of select="./@height"/>,
	                    closeAction:'hide',
	                    closable: false,
	                    collapsible: true,
	                    animCollapse: false,
	                    plain: true,
	                    x: <xsl:value-of select="./@left"/>,
	                    y: <xsl:value-of select="./@top"/>,
	                    items: [ {              
	                            html: '<xsl:call-template name="WINDOW"/>',
	                            border: false
	                            }]
	                });
	                win.show(this);
	            </xsl:if>
	        </xsl:for-each>
	    }
	
	
	    /**
	    * init extJS
	    */
	    function  init_iGeo () {
	        try {
	            initOverlayWindows();
	        } catch(e) {
	            alert( "initOverlayWindows: " + e);
	        }
	         
            try {
	            initMenubar();
	        } catch(e) {
	            alert( "initMenubar: " + e);
	        }
            
	        var tpTab = new Ext.TabPanel({                  
	            activeTab: 0,
	            height: 800,        
	            id: 'TabPanel',
	            border: false,
	            items:[
	                {
	                    title: 'Map',
	                    border: false,
	                    items: [
	                        {
	                            id: 'MapPanel',
	                            border: false,
	                            <xsl:call-template name="MAPBORDER"/>
	                        }
	                    ]
	                },
                    {
                        title: 'owsWatch',
                        border: false,
                        items: [
                            {
                                border: false,
	                            html: '<iframe id="owsWatch" src="/owswatch/owsWatch_login.html" width="100%" height="600" frameborder="0" scrolling="auto"/>'
                            }
                        ]
                    },
                    {
                        title: 'Information',
                        border: false,
                        html: '<iframe id="addTabs" src="modules/tabinfo/README_HowToAddTabs.txt" width="100%" height="600" frameborder="0" scrolling="no"/>'
                    }
	            ]
	        });
	            
	        var vp ;
	        try {
	            vp = new Ext.Viewport (
	                {
	                    listeners: {
	                    resize: {
	                        fn: function(el, width, height) {
	                            if ( vp != null ) {
	                                 var mp = Ext.getCmp( 'MapPanel' );
	                                 if ( mp != null ) {
                                         mp.setHeight( height - 60 - 0 - 28 ); // mpHeight = height - region:north(height) - region:north(split) - tab height
	                                     mp.setWidth( width );
	                                 }                                       
	                                 var cf = Ext.getCmp( 'TabPanel' );
	                                 if ( cf != null ) {
                                         cf.setHeight( height - 60 ); // mpHeight = height - region:north(height)
	                                     cf.setWidth( width );
	                                 }
	                                /*
                                    var ifr = document.getElementById( "helpFrame" );
	                                if ( ifr != null ) {
	                                    ifr.height = height - 60; // mpHeight = height - region:north(height)
	                                    ifr.width = width;
	                                }
                                    */
	                            }
	                        }
	                    }
	                },
	                    layout: 'border',                           
	                    items:[
	                        {
	                            region: 'north',
                                collapsible: false,
                                split: false, // false=0, true=5
                                height: 60,
                                //html: '<img border="0" src="./images/logo-deegree.png"></img> iGeoPortal'
                                html: '<iframe frameborder="0" marginheight="0" marginwidth="0" scrolling="no" width="100%" height="60" src="header_extjs.jsp"></iframe>'
	                        },
	                        {
	                            id: 'centerfield',
	                            region: 'center',
	                            items:[ tpTab ]
	                        }
	                    ]
	                }
	            ); // end of viewport
	        } catch(e) {
	            alert( "create viewport: " + e);
	        }
	        
	        try {   
	            vp.render();
	        } catch(e) {
	            alert( "render viewport: " + e);
	        }
	        var k = 1;
	        if ( Math.random() &gt;= 0.5 ) {
	            k = -1;
	        }
	        
	        if ( navigator.appName.indexOf( "Microsoft" )!=-1 ) {              
               try  {
                    window.resizeTo(  document.body.offsetWidth - 1 , document.body.offsetHeight );
               } catch( e ) {
                    alert( "IE resize: " +  e);
               }
            } else {
               //window.resizeTo( window.innerWidth + 13 , screen.availHeight ); 
               var t = new Ext.util.DelayedTask( window.resizeTo,  window, [window.outerWidth-k , window.outerHeight] );
               t.delay( 500 );
            }
	        window.resizeBy( k, k );
	        window.resizeBy( -k, -k );
	        
	    } ;// end init function     

    </xsl:template>
</xsl:stylesheet>            