//$HeadURL: svn+ssh://jwilden@svn.wald.intevation.org/deegree/apps/igeoportal-standard/branches/2.5_testing/javascript/style.js $
/*----------------------------------------------------------------------------
 This file is part of deegree, http://deegree.org/
 Copyright (C) 2001-2009 by:
 - Department of Geography, University of Bonn -
 and
 - lat/lon GmbH -

 This library is free software; you can redistribute it and/or modify it under
 the terms of the GNU Lesser General Public License as published by the Free
 Software Foundation; either version 2.1 of the License, or (at your option)
 any later version.
 This library is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 details.
 You should have received a copy of the GNU Lesser General Public License
 along with this library; if not, write to the Free Software Foundation, Inc.,
 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

 Contact information:

 lat/lon GmbH
 Aennchenstr. 19, 53177 Bonn
 Germany
 http://lat-lon.de/

 Department of Geography, University of Bonn
 Prof. Dr. Klaus Greve
 Postfach 1147, 53001 Bonn
 Germany
 http://www.geographie.uni-bonn.de/deegree/

 e-mail: info@deegree.org
----------------------------------------------------------------------------*/

function getDefaultStyle() {
	var ps = new PointSymbolizer("#000000", "#FFFF00", 1, 7, 1, null);
	var ls = new LineSymbolizer( ps, "#000000", 2, null, 1);
	var pgs = new PolygonSymbolizer( ps, ls, "#FFFFFF", 1);
	return new Style( ps, ls, pgs, null );
}

/**
* style class
*/
function Style(point, line, polygon, text) {
	this.point = point;
	this.line = line;
	this.polygon = polygon;
	this.text = text;
}

function PointSymbolizer(fgcolor, bgcolor, mark, size, opacity, image) {
	this.fgcolor = fgcolor;
	this.bgcolor = bgcolor;
	// 1 = circle
	// 2 = square
	// 3 = diamond
	// 4 = cross
	// 6 = across
	// 6 = star
	this.mark = mark;
	this.size = size;
	this.opacity = opacity;
	this.image = image;
}

function LineSymbolizer(point, color, width, dasharray, opacity) {
	this.point = point;
	this.color = color;
	this.width = width;
	this.dasharray = dasharray;
	this.opacity = opacity;
}

function PolygonSymbolizer(point, line, fillColor, opacity) {
	this.point = point;
	this.line = line;
	this.fillColor = fillColor;
	this.opacity = opacity;
}

function TextSymbolizer(color, size, opacity) {
	this.color = color;
	this.size = size;
	this.opacity = opacity;
}